;Draws a filled box on screen

;===============DrawBox by Donald Straney==============
;
;58 bytes/25147 cycles (for a 16x16 box)
;Inputs: b,c - one corner of box
;        d,e - other corner of box
;
;Outputs: box drawn on screen
;

drawbox:
	ld a,b
	cp d
	jr c,drawbox_noswap_bd
	ld a,b
	ld b,d
	ld d,a
drawbox_noswap_bd:
	ld a,c
	cp e
	jr c,drawbox_noswap_ce
	ld a,c
	ld c,e
	ld e,a
drawbox_noswap_ce:				;bc=upper-right corner, de=lower-left corner
	call FindPixel				;hl=address
	push af
	ld a,h
drawbox_vid_patch	equ	$+1
	add a,$fc
	ld h,a
	ld a,d
	sub b
	ld (drawbox_width_patch),a		;a=width
	ld a,e
	sub c
	ld b,a						;b=height
	pop af
	ld de,16					;de=newline addition
drawbox_loop:
	push bc
	push hl
	push af
drawbox_width_patch	equ	$+1
	ld b,0						;b=width
drawbox_inner_loop:
	ld c,a
	or (hl)
	ld (hl),a
	ld a,c
	rrca
	call c,drawbox_inner_loop_inc	;if at end of this byte, move to next
	djnz drawbox_inner_loop
drawbox_inner_loop_end:
	pop af
	pop hl
	pop bc
	add hl,de					;hl to next line
	djnz drawbox_loop
	ret
drawbox_inner_loop_inc:
	inc hl
	ret


FindPixel:						;the findpixel that came with Jimmy Mardell's FLine ;-)
 push bc
 push de
 ld hl,ExpTable
 ld d,0
 ld a,b
 and $07
 ld e,a
 add hl,de
 ld e,(hl)
 ld h,d
 srl b
 srl b
 srl b
 ld a,c
 add a,a
 add a,a
 ld l,a
 add hl,hl
 add hl,hl
 ld a,e
 ld e,b
 add hl,de
 pop de
 pop bc
 ret

ExpTable:
 .db $80,$40,$20,$10,$08,$04,$02,$01

.end